import{s as he,n as ve,o as ye}from"../chunks/scheduler.389d799c.js";import{S as we,i as $e,g as l,s as a,r as q,A as be,h as o,f as i,c as s,j as me,u as z,x as r,k as ge,y as xe,a as n,v as A,d as H,t as L,w as S}from"../chunks/index.8f81d18f.js";import{H as k,E as Ce}from"../chunks/EditOnGithub.33306dfe.js";function Te(ie){let u,U,E,j,c,I,p,ne="Autoscaling allows you to dynamically adjust the number of endpoint replicas running your models based on traffic and accelerator utilization. By leveraging autoscaling, you can seamlessly handle varying workloads while optimizing costs and ensuring high availability.",G,d,B,f,ae="The autoscaling process is triggered based on the accelerator’s utilization metrics. The criteria for scaling differ depending on the type of accelerator being used:",W,m,se="<li><p><strong>CPU Accelerators</strong>: A new replica is added when the average CPU utilization of all replicas reaches 80%.</p></li> <li><p><strong>GPU Accelerators</strong>: A new replica is added when the average GPU utilization of all replicas over a 1-minute window reaches 80%.</p></li>",D,g,le="It’s important to note that the scaling up process takes place every minute and scaling down takes place every 2 minutes. This frequency ensures a balance between responsiveness and stability of the autoscaling system, with a stabilization of 300 seconds once scaled down.",O,h,R,v,oe="You can change the scaling criteria to be based on pending requests instead of utilization metrics. This is currently an experimental feature and we advise testing prior to using it for production workloads.",Y,y,re="<li>pending requests are requests that have not yet received an HTTP status, meaning they include in-flight requests and requests currently being processed.</li> <li>by default, if there are more than 1.5 pending requests per replica in the past 20 seconds, it triggers an autoscaling event and adds a replica to your deployment.<ul><li>you can adjust this threshold to meet your specific requirements under Endpoint settings.</li></ul></li>",Z,w,F,$,ue="While autoscaling offers convenient resource management, certain considerations should be kept in mind to ensure its effectiveness:",J,b,ce='<li><p><strong>Model Initialization Time</strong>: During the initialization of a new replica, the model is downloaded and loaded into memory. If your replicas have a long initialization time, autoscaling may not be as effective. This is because the average GPU utilization might fall below the threshold during that time, triggering the automatic scaling down of your endpoint.</p></li> <li><p><strong>Enterprise Plan Control</strong>: If you have an <a href="https://huggingface.co/inference-endpoints/enterprise" rel="nofollow">enterprise plan</a>, you have full control over the autoscaling definitions. This allows you to customize the scaling thresholds, behavior and criteria based on your specific requirements.</p></li>',K,x,N,C,pe="Inference Endpoints also supports autoscaling to 0, which means reducing the number of replicas to 0 when there is no incoming traffic. This feature is based on request patterns rather than accelerator utilization. When an endpoint remains idle without receiving any requests for over 15 minutes, the system automatically scales down the endpoint to 0 replicas. To enable the feature, go to the Settings page and you’ll find a section called “Automatic Scale-to-Zero”.",Q,T,de="Scaling to 0 replicas helps optimize cost savings by minimizing resource usage during periods of inactivity. However, it’s important to be aware that scaling to 0 implies a cold start period when the endpoint receives a new request. Additionally, the HTTP server will respond with a status code <code>502 Bad Gateway</code> while the new replica is initializing. Please note that there is currently no queueing system in place for incoming requests. Therefore, we recommend developing your own request queue client-side with proper error handling to optimize throughput and latency.",V,_,fe="The duration of the cold start period varies depending on your model’s size. It is recommended to consider the potential latency impact when enabling scaling to 0 and managing user expectations.",X,P,ee,M,te;return c=new k({props:{title:"Autoscaling",local:"autoscaling",headingTag:"h1"}}),d=new k({props:{title:"Scaling Criteria",local:"scaling-criteria",headingTag:"h2"}}),h=new k({props:{title:"Scaling based on pending requests (beta feature)",local:"scaling-based-on-pending-requests-beta-feature",headingTag:"h3"}}),w=new k({props:{title:"Considerations for Effective Autoscaling",local:"considerations-for-effective-autoscaling",headingTag:"h2"}}),x=new k({props:{title:"Scaling to 0",local:"scaling-to-0",headingTag:"h2"}}),P=new Ce({props:{source:"https://github.com/huggingface/hf-endpoints-documentation/blob/main/docs/source/autoscaling.mdx"}}),{c(){u=l("meta"),U=a(),E=l("p"),j=a(),q(c.$$.fragment),I=a(),p=l("p"),p.textContent=ne,G=a(),q(d.$$.fragment),B=a(),f=l("p"),f.textContent=ae,W=a(),m=l("ul"),m.innerHTML=se,D=a(),g=l("p"),g.textContent=le,O=a(),q(h.$$.fragment),R=a(),v=l("p"),v.textContent=oe,Y=a(),y=l("ul"),y.innerHTML=re,Z=a(),q(w.$$.fragment),F=a(),$=l("p"),$.textContent=ue,J=a(),b=l("ul"),b.innerHTML=ce,K=a(),q(x.$$.fragment),N=a(),C=l("p"),C.textContent=pe,Q=a(),T=l("p"),T.innerHTML=de,V=a(),_=l("p"),_.textContent=fe,X=a(),q(P.$$.fragment),ee=a(),M=l("p"),this.h()},l(e){const t=be("svelte-u9bgzb",document.head);u=o(t,"META",{name:!0,content:!0}),t.forEach(i),U=s(e),E=o(e,"P",{}),me(E).forEach(i),j=s(e),z(c.$$.fragment,e),I=s(e),p=o(e,"P",{"data-svelte-h":!0}),r(p)!=="svelte-1cik5b8"&&(p.textContent=ne),G=s(e),z(d.$$.fragment,e),B=s(e),f=o(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-15ptey4"&&(f.textContent=ae),W=s(e),m=o(e,"UL",{"data-svelte-h":!0}),r(m)!=="svelte-1jeubu7"&&(m.innerHTML=se),D=s(e),g=o(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-1mnkhxs"&&(g.textContent=le),O=s(e),z(h.$$.fragment,e),R=s(e),v=o(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-1j9j645"&&(v.textContent=oe),Y=s(e),y=o(e,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-n46z1c"&&(y.innerHTML=re),Z=s(e),z(w.$$.fragment,e),F=s(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-m86usn"&&($.textContent=ue),J=s(e),b=o(e,"UL",{"data-svelte-h":!0}),r(b)!=="svelte-mm7v54"&&(b.innerHTML=ce),K=s(e),z(x.$$.fragment,e),N=s(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-15noffw"&&(C.textContent=pe),Q=s(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-rmhk41"&&(T.innerHTML=de),V=s(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-11efh16"&&(_.textContent=fe),X=s(e),z(P.$$.fragment,e),ee=s(e),M=o(e,"P",{}),me(M).forEach(i),this.h()},h(){ge(u,"name","hf:doc:metadata"),ge(u,"content",_e)},m(e,t){xe(document.head,u),n(e,U,t),n(e,E,t),n(e,j,t),A(c,e,t),n(e,I,t),n(e,p,t),n(e,G,t),A(d,e,t),n(e,B,t),n(e,f,t),n(e,W,t),n(e,m,t),n(e,D,t),n(e,g,t),n(e,O,t),A(h,e,t),n(e,R,t),n(e,v,t),n(e,Y,t),n(e,y,t),n(e,Z,t),A(w,e,t),n(e,F,t),n(e,$,t),n(e,J,t),n(e,b,t),n(e,K,t),A(x,e,t),n(e,N,t),n(e,C,t),n(e,Q,t),n(e,T,t),n(e,V,t),n(e,_,t),n(e,X,t),A(P,e,t),n(e,ee,t),n(e,M,t),te=!0},p:ve,i(e){te||(H(c.$$.fragment,e),H(d.$$.fragment,e),H(h.$$.fragment,e),H(w.$$.fragment,e),H(x.$$.fragment,e),H(P.$$.fragment,e),te=!0)},o(e){L(c.$$.fragment,e),L(d.$$.fragment,e),L(h.$$.fragment,e),L(w.$$.fragment,e),L(x.$$.fragment,e),L(P.$$.fragment,e),te=!1},d(e){e&&(i(U),i(E),i(j),i(I),i(p),i(G),i(B),i(f),i(W),i(m),i(D),i(g),i(O),i(R),i(v),i(Y),i(y),i(Z),i(F),i($),i(J),i(b),i(K),i(N),i(C),i(Q),i(T),i(V),i(_),i(X),i(ee),i(M)),i(u),S(c,e),S(d,e),S(h,e),S(w,e),S(x,e),S(P,e)}}}const _e='{"title":"Autoscaling","local":"autoscaling","sections":[{"title":"Scaling Criteria","local":"scaling-criteria","sections":[{"title":"Scaling based on pending requests (beta feature)","local":"scaling-based-on-pending-requests-beta-feature","sections":[],"depth":3}],"depth":2},{"title":"Considerations for Effective Autoscaling","local":"considerations-for-effective-autoscaling","sections":[],"depth":2},{"title":"Scaling to 0","local":"scaling-to-0","sections":[],"depth":2}],"depth":1}';function Pe(ie){return ye(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class He extends we{constructor(u){super(),$e(this,u,Pe,Te,he,{})}}export{He as component};
